Index: trunk/TODO
===================================================================
--- trunk/TODO	(revision 282)
+++ trunk/TODO	(revision 283)
@@ -1,13 +1,23 @@
+***** Code
+- lhco 
+- corriger le bfield
+- lhe2pythia d'office?
+- permettre de rentrer un histo pour le smearing (Giacomo)
+- operator<<
+- corriger le makefile
+- TriggerUtil.cc:335 : mettre des else devant les if ?
+
  - smearer le IP
- - il n'y a pas encore de smearing pour les RP et le ZDC
- - le ZDC ne mesure-t-il pas uniquement des Ã©nergies (pas de px,py,pz) ?
- - timing pour ZDC et FP420? <-> vÃ©rifier que particle->Z est bien en micromÃštres! <-> quelles unitÃ©s pour particle->T ?
-_____________------->les positions des vertex sont donnes en MM et particule->T renvoie "production time en mm/c"
  - gÃ©rer les cout des warnings et des erreur
  - electrons/muons : misidentification of the charge
  - rootlogon.C <- "no dictionnary for class" + styleTDR
- - CASTOR not yet included
  - vÃ©rifier les unitÃ©s des toutes les valeurs dans les ttree
- - il manque CASTOR dans le log de sortie...
+
+ - FLAG_zdc <-> pas complet, notamment dans le fichier log
+ - CASTOR not yet included ; il manque CASTOR dans le log de sortie...
+ - timing pour ZDC et FP420? <-> vÃ©rifier que particle->Z est bien en micromÃštres! <-> quelles unitÃ©s pour particle->T ? ->les positions des vertex sont donnes en MM et particule->T renvoie "production time en mm/c"
+ - le ZDC ne mesure-t-il pas uniquement des Ã©nergies (pas de px,py,pz) ?
+ - il n'y a pas encore de smearing pour les RP et le ZDC
+
  - mettre un test sur le type de fichier d'entrÃ©e (list ou root) pour l'exemple d'analyse (et pour Delphes?)
    + ajouter la possibilitÃ© de tourner sur un rootfile unique
@@ -16,4 +26,5 @@
  - si la simulation du bfield est beaucoup plus rapide, retirer le FLAG_bfield du code
  - Doxygen du code
+
  - copy constructors des classes ; passage par reference ; gprof tool <-> option -gp
  - valgrind <-> -g <-> definitely lost / probably lost
@@ -21,5 +32,48 @@
  - TreeClassesLinkDef ???
  - libHector.so = libUtilities.so !!!!!
- - FLAG_zdc <-> pas complet, notamment dans le fichier log
+
  - LHCO http://cp3wks05.fynu.ucl.ac.be/Manual/lhco.html
  - Hector @ 5 TeV
+ - particules invisibles  idhep(ihep).eq.1000022 .or. idhep(ihep).eq.1000039  ocmme des eutrinos dans PGS
+
+
+
+***** Physique
+- vÃ©rifier les rÃ©solutions des calos, d'aprÃšs David, idem b-tag
+  --> jdf: CMS pTDR btag = 0.4 ; 0.03 ; 0.001 --><-- 0.4; 0.1; 0.01 !
+- crÃ©er un dÃ©tecteur en modules (Andrea)
+- dÃ©finition de MET?
+--> photons commencent leur gerbe plus tard 9/7 X_0
+-> david: b-tag : sÃ©parer les gluons des light-quarks :mis-tag difficile
+   -> b-mistag t-jets?
+-> quid ETmis nouvelles particules?
+- avant/aprÃšs energy_flow: nombre de photons fort diffÃ©rent!
+
+***** Publi / manuel
+- Journaux possibles pour publier:
+  Journal of Computational Physics Impact Factor: 2.372  Issues per year: 24
+  Computer Physics Communications  Impact Factor: 1.842  Issues per year: 12
+- no other charged particle with $p_T>2~\textrm{GeV}/c$ within a cone ; mettre Ã§a dans la datacard idem cone 0.5
+- mettre dans le papier/manuel les nouveuates FP420 et RP220
+- mettre dans la datacard et dans le manuel les choix possibles pour les algos de jet
+
+
+***** Delphes 2.0
+   - operator<< in classes
+	- permettre d'avoir diffÃ©rents formats de fichier dans la liste d'entrÃ©e
+	- trigger card: coupure en ETA possible ; permettre de faire un OR et pas
+seulement des AND
+   - permettre de crÃ©er un dÃ©tecteur composant par composant.
+     chaque sous-dÃ©tecteur doit Ãªtre caractÃ©risÃ© par
+		- la couverture en eta
+		- la couverture en phi
+		- le type de mesures  (E, pT, eta, phi, x,y,z,r,t)
+        - resolution
+        - cartes CDF, D0; ilc? hera?
+        - cartes d'inefficacitÃ©s en eta/phi (pour tenir compte des cracks)
+        - CLHep ? <- unitÃ©s et constantes dedans, HepMC
+        ? se factoriser de ROOT
+        ? Savannah - twiki - doxygen
+        - aperture effects devant le ZDC?
+		- Pile-up mixer?
+        - ajouter du pile-up minbias en quantitÃ© "arbitraire"